int midi_startin(void)
{
 if (midiInOpen(&in_handle,midi_device_in-1,
  NULL,NULL,CALLBACK_NULL)!=MMSYSERR_NOERROR)
  return(0);

 memset(&minbuf_hdr,0,sizeof(MIDIHDR));
 minbuf_hdr.lpData=midi_in_buffer;
 minbuf_hdr.dwBufferLength=sizeof(midi_in_buffer);             
 minbuf_hdr.dwBytesRecorded=NULL;      
 /* minbuf_hdr.dwUser=NULL; */
 minbuf_hdr.dwFlags=NULL;                 
 /* minbuf_hdr.midihdr_tag=NULL; */ 
 /* minbuf_hdr.reserved=NULL; */           
 /* minbuf_hdr.dwOffset=NULL; */             
 /* minbuf_hdr.dwReserved[4]=NULL; */ 

 midiInPrepareHeader(in_handle,&minbuf_hdr,sizeof(MIDIHDR));
 midiInAddBuffer(in_handle,&minbuf_hdr,sizeof(MIDIHDR)); 
 midiInStart(in_handle);
 return(1);
}

int midi_send(int bytes)
{ 
 if (midiOutOpen(&out_handle,midi_device_out-1,
  NULL,NULL,CALLBACK_NULL)!=MMSYSERR_NOERROR)
  return (0);

 memset(&moutbuf_hdr,0,sizeof(MIDIHDR));
 moutbuf_hdr.lpData=midi_out_buffer;
 moutbuf_hdr.dwBufferLength=bytes;
	 
 /* Be sure buffer length is data length and not literal
 buffer data object length. To ensure trailing garbage 
 is not transmit.
  */
  
 moutbuf_hdr.dwBytesRecorded=NULL;      
 /* moutbuf_hdr.dwUser=NULL; */
 moutbuf_hdr.dwFlags=NULL;                 
 /* moutbuf_hdr.midihdr_tag=NULL; */ 
 /* moutbuf_hdr.reserved=NULL; */           
 /* moutbuf_hdr.dwOffset=NULL; */             
 /* moutbuf_hdr.dwReserved[4]=NULL; */ 

 midiOutPrepareHeader(out_handle,&moutbuf_hdr,sizeof(MIDIHDR));
 midiOutLongMsg(out_handle,&moutbuf_hdr,sizeof(MIDIHDR));
 midiOutReset(out_handle);
 midiOutUnprepareHeader(out_handle,&moutbuf_hdr,sizeof(MIDIHDR));
 midiOutClose(out_handle);

 return(1);
}

int midi_receive(void)
{
 midiInStop(in_handle);
 midiInReset(in_handle);
 midiInUnprepareHeader(in_handle,&minbuf_hdr,sizeof(MIDIHDR));
 midiInClose(in_handle);
 return((DWORD)minbuf_hdr.dwBytesRecorded);
}

int midi_pause(int millies)

/* Let the CZ-101 have enough time to respond. Could have
been done better with the set timer, and wndproc, but
more complex that way */

{
 Sleep((DWORD)millies);
 return(1);
}

int midi_init_dialog(HWND dialog_hwnd)

{
 int count;
 MIDIINCAPS midi_in_caps;
 MIDIOUTCAPS midi_out_caps;

 SendDlgItemMessage
  (dialog_hwnd,CZ_MEMORY,LB_ADDSTRING,0,(LPARAM) "Presets");
 SendDlgItemMessage
  (dialog_hwnd,CZ_MEMORY,LB_ADDSTRING,0,(LPARAM) "Internal");
 SendDlgItemMessage
  (dialog_hwnd,CZ_MEMORY,LB_ADDSTRING,0,(LPARAM) "Cartridge");
 SendDlgItemMessage
  (dialog_hwnd,CZ_MEMORY,LB_SETCURSEL,cz_memory,0);

 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 01");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 02");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 03");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 04");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 05");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 06");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 07");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 08");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 09");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 10");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 11");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 12");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 13");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 14");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 15");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_ADDSTRING,0,(LPARAM) "Channel 16");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_CH,LB_SETCURSEL,midi_channel_num-1,0);

 SendDlgItemMessage
  (dialog_hwnd,MIDI_IN,LB_ADDSTRING,0,(LPARAM) "None");
 SendDlgItemMessage
  (dialog_hwnd,MIDI_OUT,LB_ADDSTRING,0,(LPARAM) "None");

 for (count=1;count<=midi_in_devices;count++) 
 {
  midiInGetDevCaps(count-1,&midi_in_caps,sizeof(MIDIINCAPS));
  SendDlgItemMessage(dialog_hwnd,MIDI_IN,LB_ADDSTRING,
   0,(LPARAM) midi_in_caps.szPname);
 }
 for (count=1;count<=midi_out_devices;count++) 
 {
  midiOutGetDevCaps(count-1,&midi_out_caps,sizeof(MIDIOUTCAPS));
  SendDlgItemMessage(dialog_hwnd,MIDI_OUT,LB_ADDSTRING,
   0,(LPARAM) midi_out_caps.szPname);
 }

 SendDlgItemMessage
  (dialog_hwnd,MIDI_IN,LB_SETCURSEL,midi_device_in,0);
 SendDlgItemMessage
  (dialog_hwnd,MIDI_OUT,LB_SETCURSEL,midi_device_out,0);

return (1);
}

int patch_init_dialog(HWND dialog_hwnd)

{
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 01");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 02");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 03");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 04");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 05");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 06");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 07");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 08");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 09");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 10");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 11");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 12");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 13");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 14");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 15");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_ADDSTRING,0,(LPARAM) "Channel 16");
 SendDlgItemMessage
  (dialog_hwnd,PA_DISC,LB_SETCURSEL,patch_disc,0);

  SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 01");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 02");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 03");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 04");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 05");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 06");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 07");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 08");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 09");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 10");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 11");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 12");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 13");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 14");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 15");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_ADDSTRING,0,(LPARAM) "Channel 16");
 SendDlgItemMessage
  (dialog_hwnd,PA_CZ,LB_SETCURSEL,patch_cz,0);

 return (1);
}

int cz_test_online(void)
{ 
 int ack_ok;
 int retries;
 
 for (retries=0;retries<=2;retries++)
 {
  midi_out_buffer[0]=(char)0xF0;
  midi_out_buffer[1]=(char)0x44;
  midi_out_buffer[2]=(char)0x00;
  midi_out_buffer[3]=(char)0x00;
  midi_out_buffer[4]=(char)0x70+(midi_channel_num-1);
  midi_out_buffer[5]=(char)0x10;
  midi_out_buffer[6]=(char)0x20;
  midi_out_buffer[7]=(char)0x70+(midi_channel_num-1);
  midi_out_buffer[8]=(char)0x31;
  midi_out_buffer[9]=(char)0xF7;
 
  if (midi_startin()==0) 
   {
    error_code=1;
    draw_cz_window();
	return(0);
   } 
  if (midi_send(10)==0) 
   {
    error_code=1;
    draw_cz_window();
	return(0);
   } 
  
  midi_pause(1300);
  ack_ok=1;
  if (midi_receive()==263)
  {	  
   if (midi_in_buffer[0]!=(char)0xF0) ack_ok=0;
   if (midi_in_buffer[1]!=(char)0x44) ack_ok=0;
   if (midi_in_buffer[2]!=(char)0x00) ack_ok=0;
   if (midi_in_buffer[3]!=(char)0x00) ack_ok=0;
   if (midi_in_buffer[5]!=(char)0x30) ack_ok=0;
   if (midi_in_buffer[262]!=(char)0xF7) ack_ok=0;
  } else ack_ok=0;
  if (ack_ok==1) return(1); 
 }

 error_code=3;
 draw_cz_window();
 return(0);
}
 
